Attribute VB_Name = "Img"
'bugfix 12.24.15: possible overflow in resize total calc..

'todo: tool to auto rotate all in a folder
'      tool to build index.html for all picts


Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long

Public Enum ImgType
    jpeg = 1
    BITMAP = 2
End Enum

Public Enum Qualty
    Best = 100
    High = 85
    Medium = 75
    Low = 60
End Enum

Global Quality As Qualty

Public Function ClearImage()
    frm.inPic = LoadPicture()
    frm.Resized = LoadPicture()
End Function

Public Function LoadImage(path As String) As Boolean
    On Error GoTo skip
    frm.inPic = LoadPicture(path)
    frm.inPic.Refresh
    LoadImage = True
 Exit Function
skip: LoadImage = False
End Function

Public Function CreateThumb(maxWidth As Long, maxHeight As Long)
    frm.lblMsg = "Creating Thumb..."
    
    Dim widthIsMax As Boolean
    maxWidth = maxWidth * Screen.TwipsPerPixelX
    maxHeight = maxHeight * Screen.TwipsPerPixelY
    percentwidth = 1 / (frm.inPic.Width / maxWidth)
    percentheight = 1 / (frm.inPic.Height / maxHeight)
    
    'find out which is the limiting dimension so we can scale proportionatly
    widthIsMax = IIf(percentwidth > percentheight, True, False)
    If widthIsMax And (frm.inPic.Height * percentwidth) > maxHeight Then
        widthIsMax = False
    End If
    
    If widthIsMax Then
        frm.Resized.Width = maxWidth
        frm.Resized.Height = frm.inPic.Height * percentwidth
    Else
        frm.Resized.Height = maxHeight
        frm.Resized.Width = frm.inPic.Width * percentheight
    End If
    
    Call ResizePict
    frm.lblMsg = "Picture Resize Complete..."
End Function

Private Sub StreachBltResizePict() 'By Arvinder Sehmi (Arvinder@Sehmi.org.uk)
  With frm                         'fast but only 256 color
    Call StretchBlt(.Resized.hdc, 0, 0, _
                     .Resized.Width / Screen.TwipsPerPixelX, _
                     .Resized.Height / Screen.TwipsPerPixelY, _
                     .inPic.hdc, 0, 0, _
                     .inPic.Width / Screen.TwipsPerPixelX, _
                     .inPic.Height / Screen.TwipsPerPixelY, vbSrcCopy _
                    )
    .Resized.Refresh
  End With
End Sub

Private Function ResizePict() 'By Arvinder Sehmi (Arvinder@Sehmi.org.uk)
    frm.lblMsg = "Resizing Picture..."
     
    Dim rX, rY, Total As Long
    With frm
        Total = .inPic.Height
        For y = 0 To .inPic.Height Step ((.inPic.Height / .Resized.Height) * 15) '-Cycle ThroughLarge Image
           For x = 0 To .inPic.Width Step ((.inPic.Width / .Resized.Width) * 15) '/
               SetPixel .Resized.hdc, rX / 15, rY / 15, GetPixel(.inPic.hdc, x / 15, y / 15) ' Get Every Other Pixel, and Place It Down In Another Picturebox
               rX = rX + 15 ' Set Pixel Position On Small Image
           Next x
           .Resized.Refresh
           rY = rY + 15 ' Goto Next Line
           rX = 0 ' Start On Left Side
           .lblPercent = CInt((y / Total) * 100) & "%"
           DoEvents: DoEvents
        Next
        .lblPercent = ""
    End With
End Function

Public Sub SaveImage(path As String, saveAs As ImgType)
     frm.lblMsg = "Saving Image..."
    
    'if pict already exists it will be saved over n/p
    With frm.Resized
        Set .Picture = .Image
        If saveAs = BITMAP Then
           ext = fso.GetExtension(path)
           If ext <> ".bmp" Then path = fso.ChangeExt(path, ".jpg")
           Call SavePicture(.Picture, path)
        Else
           frm.lblMsg = "Converting Image to Jpg..."
           Call Bmp2Jpg(path)
           frm.lblMsg = ""
        End If
    End With
End Sub

Private Sub Bmp2Jpg(saveAs As String)
   
   Dim c As cDIBSection
   Set c = New cDIBSection
   c.CreateFromPicture frm.Resized.Picture
   If Not SaveJPG(c, saveAs, Quality) Then MsgBox "Failed to save " & saveAs
   '                         ^^^ Global set with combo2_click
End Sub
