Attribute VB_Name = "fso"
'this is just part of a full compile in object model
'that mimics the use of the MS Scripting.FileSystemObject
'I made it so projects relying on the MS Dll could be
'easily converted over and to lose the dependancy on the
'MS DLL which has alot of differnet versions. This obj model
'also contains a full set of classes to manipulate binary files
'just as efficently. The full project is available at:
'
'   http://www.geocities.com/dzzie
'
'both as a DLL to use in small projects as well as teh
'compile in version.    -dzzie

Public Type tFile
    baseName As String
    fullName As String
    fullpath As String
    filesize As Long
    extension As String
    parentFolder As String
    Attributes As VbFileAttribute
End Type
    
Public Type DirectoryContents
    sFolders As Collection
    sFiles As Collection
End Type

Public Function GetFileProps(filePath As String) As tFile
    Dim f As tFile
    tmp = Split(filePath, "\")
    ub = tmp(UBound(tmp))
    If InStr(1, ub, ".") > 0 Then
       f.baseName = Mid(ub, 1, InStr(1, ub, ".") - 1)
       f.extension = Mid(ub, InStrRev(ub, "."), Len(ub))
    Else
       f.baseName = ub
       f.extension = ""
    End If
    f.fullName = ub
    f.fullpath = filePath
    If fso.FileExists(filePath) Then
        f.filesize = FileLen(filePath)
        f.Attributes = GetAttr(filePath)
    End If
    f.parentFolder = Replace(Join(tmp, "\"), "\" & ub, "")
    GetFileProps = f
End Function

Public Function GetDirContents(path As String, Optional extension = ".*") As DirectoryContents
   Dim dc As DirectoryContents
   Set dc.sFiles = New Collection
   Set dc.sFolders = New Collection
   
   If Right(path, 1) <> "\" Then path = path & "\"
   If Left(extension, 1) = "*" Then extension = Mid(extension, 2, Len(extension))
   If Left(extension, 1) <> "." Then extension = "." & extension
   
   fs = Dir(path & "*" & extension, vbHidden Or vbNormal Or vbReadOnly Or vbSystem)
   While fs <> ""
     If fs <> "" Then dc.sFiles.Add fs
     fs = Dir()
   Wend

   fd = Dir(path, vbDirectory)
   While fd <> ""
     If Left(fd, 1) <> "." Then
        If (GetAttr(path & fd) And vbDirectory) = vbDirectory Then
           dc.sFolders.Add fd
        End If
     End If
     fd = Dir()
   Wend
   
   GetDirContents = dc
End Function

Public Function FolderExists(path As String) As Boolean
  If Dir(path, vbDirectory) <> "" Then FolderExists = True _
  Else FolderExists = False
End Function

Public Function FileExists(path As String) As Boolean
  If Dir(path, vbHidden Or vbNormal Or vbReadOnly Or vbSystem) <> "" Then FileExists = True _
  Else FileExists = False
End Function

Public Function GetParentFolder(path As String) As String
    Dim base As tFile
    base = GetFileProps(path)
    GetParentFolder = base.parentFolder
End Function

Public Function GetExtension(path As String) As String
    Dim base As tFile
    base = GetFileProps(path)
    GetExtension = base.extension
End Function

Public Function GetBaseName(path As String) As String
    Dim base As tFile
    base = GetFileProps(path)
    GetBaseName = base.baseName
End Function

Public Function GetFullName(path As String) As String
    Dim base As tFile
    base = GetFileProps(path)
    GetFullName = base.fullName
End Function

Public Sub CreateFolder(path As String)
   If FolderExists(path) Then Err.Raise 911, "CreateFolder", "Specified Folder Already Exists": Exit Sub
   MkDir path
End Sub

Private Function RandomNum()
    Randomize
    tmp = Round(Timer * Now * Rnd(), 0)
    RandomNum = tmp
End Function

Public Function ChangeExt(path As String, ext As String) As String
    ext = IIf(Left(ext, 1) = ".", ext, "." & ext)
    If fso.FileExists(path) Then
        Dim t As tFile
        t = fso.GetFileProps(path)
        ChangeExtension = t.parentFolder & "\" & t.baseName & ext
    Else
        'hack to just accept a file name might not be worth supporting
        bn = Mid(path, 1, InStr(1, path, ".") - 1)
        ChangeExtension = bn & ext
    End If
End Function
